# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
try:
	from urllib import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs, urlunparse
except ImportError:
	from urllib.parse import urlparse, parse_qs, urlunparse
from xml.dom.minidom import parseString
import re

def httpget(url):
	try:
		return urlopen(url).read().decode('utf-8')
	except:
		print url
		print 'captured'
		return False

def item(title, data, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(data), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	item('exodiver', {'url': 'https://github.com/exodiver/IPTV/tree/master/'})
	item('freearhey', {'url': 'https://github.com/freearhey/IPTV/tree/master/channels'})
	xbmcplugin.endOfDirectory(handle)
else:
	d = parse_qs(urlparse(sys.argv[2]).query)
	url = d['url'][0]
	o = urlparse(url)
	p = o.path.split('/')
	if o.netloc == 'github.com':
		if p[3] == 'blob':
			del p[3]
			url2 = urlunparse((o.scheme, 'raw.githubusercontent.com', '/'.join(p), o.params, o.query, o.fragment))
			content = httpget(url2)
			t1 = {}
			t2 = []
			for l in content.split('\n'):
				l = l.strip()
				if not l:
					continue
				if l[0] == '#':
					title = l.split(',')[-1].strip()
					group = False
					m = re.search('group-title\s*=\s*"\s*(.*?)\s*"', l)
					if m:
						group = m.group(1).strip()
				else:
					if group:
						if group not in t1:
							t1[group] = []
						t1[group].append({'title': title, 'url': l})
					else:
						t2.append({'title': title, 'url': l})
			if 'group' in d and d['group'][0].decode('utf-8') in t1:
				for e in t1[d['group'][0].decode('utf-8')]:
					item(e['title'], {'url': e['url']}, False)
			else:
				for e in t1:
					item(e, {'url': url, 'group': e.encode('utf-8')})
				for e in t2:
					item(e['title'], {'url': e['url']}, False)
		else:
			content = httpget(url)
			if content == False:
				xbmcgui.Dialog().ok('错误', '错误001')
				sys.exit(0)
			m1 = re.findall('<tr class="js-navigation-item">\s*(.*?)\s*</tr>', content, re.DOTALL)
			for e1 in m1:
				m21 = re.search('<svg\s+.*?class="[^"]*?octicon-file-directory[^"]*?".*?>.*?</svg>', e1, re.DOTALL)
				m22 = re.search('<a\s+.*?href="([^"]*?)".*?>(.*?)</a>', e1, re.DOTALL)
				if m21 and m22:
					item(m22.group(2), {'url': 'https://github.com' + m22.group(1)})
					continue
				m21 = re.search('<svg\s+.*?class="[^"]*?octicon-file[^"]*?".*?>.*?</svg>', e1, re.DOTALL)
				m22 = re.search('<a\s+.*?href="([^"]*?)".*?>(.*?)</a>', e1, re.DOTALL)
				if m21 and m22:
					item(m22.group(2), {'url': 'https://github.com' + m22.group(1)})
					continue
		xbmcplugin.endOfDirectory(handle)
	else:
		play('', url)
